module Qian
  #
  # 发送 json 数据到 Kafka 的 Logger
  #
  # @author Larry <larry@jianshu.com>
  #
  class Logger
    def initialize(kafka_producer)
      @kafka_producer = kafka_producer
    end

    #
    # Log
    #
    # @param [Hash] entry Log 到 Kafka 的数据
    # @param [Hash] options 额外的参数
    #
    # @return [void]
    #
    def log(entry = {}, options = {})
      return if entry.empty? || @kafka_producer.nil?
      topic = options[:topic] || Qian.logger_config[:topic]
      @kafka_producer.produce(entry.to_json, :topic => topic)
    end

    #
    # 批量 Log
    #
    # @param [Array] entries
    # @param [Hash] options
    #
    # @return [<type>] <description>
    #
    def log_in_batch(entries = [], options = {})
      return if entries.empty? || @kafka_producer.nil?
      entries.each { |entry| log(entry, options) }
    end
  end
end
